<?php
/* ---------------------------------------------------------------------
    download.php - MotionBrowser - User interface for the result of
                   Motion application. Developed by Carlos Ladeira
                   (caladeira@gmail.com)

    Creation:     2006-03-11  Carlos Ladeira
    Last Update:  $Id: download.php 29311 2011-12-25 14:55:48Z jed $

    For more details, please visit:
    http://www.lavrsen.dk/twiki/bin/view/Motion/WebHome

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
   -------------------------------------------------------------------- */

    // Send to download a file that isn't under the root of the web site

    //
    // instead of using readfile, use this to get more performance
    // and avoiding problems with big files
    //
    function readfile_chunked($filename,$retbytes=true)
    {
        $chunksize = 1*(1024*1024); // how many bytes per chunk
        $buffer = '';
        $cnt =0;
        $handle = fopen($filename, 'rb');
        if ($handle === false) return false;

        while (!feof($handle)) {
            $buffer = fread($handle, $chunksize);
            echo $buffer;
            ob_flush();
            flush();
            if ($retbytes) $cnt += strlen($buffer);
        }

        $status = fclose($handle);

        // return num. bytes delivered like readfile() does.
        if ($retbytes && $status) return $cnt;

        return $status;
    }

    $filename = $_GET['file'];
    $filetype = strtolower(substr(strrchr($filename,"."),1));

    // allow only to download avi files
    switch($filetype) {
        case "avi":
         // $content_type = "video/x-ms-wmv";
            $content_type = "video/x-msvideo";
            break;

        case "jpg":
            $content_type = "image/jpeg";
            break;

        case "mpg":
            $content_type = "video/mpeg";
            break;

        default:
            return;
    }

    header("Pragma: public");                           // required
    header("Expires: 0");
    header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
    header("Cache-Control: private",false);             // required for certain browsers
    header("Content-Type: " . $content_type);           // application/force-download");
    header("Content-Disposition: attachment; filename=\"" . basename($filename) . "\";" );
    header("Content-Transfer-Encoding: binary");
    header("Content-Length: " . filesize($filename));

    readfile_chunked("$filename");

    exit();
?>
