#!/bin/sh
#----------------------------------------------------------------------------------------
# /[data/packages|var]/motion/motion_send_file.sh - send file by email
#
# Copyright (c) 2011 The Eisfair Team, team(at)eisfair(dot)org
#
# Creation:     2011-10-27  jed
# Last Update:  $Id: motion_send_file.sh 29043 2011-10-27 18:50:48Z jed $
#
# Usage:        motion_send_file.sh filename|%f [receiver-address] [subject]
#
#               filename example: %f
#               subject example : Motion event appeared for camera %t on %F at %R:%Sh
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#----------------------------------------------------------------------------------------

# load eislib etc.
. /var/install/include/eistime

fromaddr="root"
hostname="`hostname`"

if [ -f /usr/local/bin/send_file_from_cmd.sh ]
then
    sscript=/usr/local/bin/send_file_from_cmd.sh
else
    sscript=/var/motion/send_file_from_cmd.sh
fi

# set filename
if [ "$1" != "" ]
then
    fname=$1

    if [ -f ${sscript} ]
    then
        # set receiver email address
        if [ "$2" != "" ]
        then
            toaddr=$2
        else
            toaddr='root@localhost'
        fi

        if [ "$3" != "" ]
        then
            subject="$3"
        else
            subject="[${hostname}] Motion event detected on ${EISDATE} at ${EISTIME}" 
        fi

        # send infomail
        {
            echo
            echo "Attached you'll find the corresponding picture/movie file:"
            echo

        } | ${sscript} -f "${fromaddr}" -s "${subject}" -t ${toaddr} -b ${fname}
    else
        echo "Error: Send script '${sscript}' couldn't be found!"
    fi
else
    echo "Error: No filename given!"
    echo
    echo "Usage: $0 filename|%f [receiver-address] [subject]"
fi
